[![KendoReact NPM Banner](https://raw.githubusercontent.com/telerik/kendo-react/master/images/kendoreact-github-banner.png)](https://www.telerik.com/kendo-react-ui/components/free?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-dialogs&utm_content=banner)

# KendoReact Dialogs Library for React

> **Important**
>
> -   This package is а part of [KendoReact](https://www.telerik.com/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-dialogs)&mdash;an enterprise-grade UI library with 120+ free and premium components.
> -   This package contains free KendoReact components. You can use it even in production, no sign-up or license required. If you're looking for more free React components, check out [Get Started with KendoReact Free](https://www.telerik.com/kendo-react-ui/components/free).
> -   Installing and working with this package indicates that you [accept the KendoReact License Agreement](https://www.telerik.com/purchase/license-agreement/progress-kendoreact?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-dialogs).
> -   The [30-day free trial](https://www.telerik.com/try/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-dialogs) gives you access to all KendoReact components and their full functionality. Additionally, for the period of your trial, you can use our legendary technical support provided directly by the KendoReact dev team!

The React Dialogs, part of KendoReact, are UI components for prompting user interaction. They provide modal and non-modal windows for showing additional information to the user, filling a form and many others.

How to start:

```sh
npm i @progress/kendo-react-dialogs
```

What's in this package:

-   [React Dialogs Library Shared Features](#react-dialogs-library-shared-features)
-   [React Dialog component (free)](#react-dialog-component)
-   [React Window component (free)](#react-window-component)

Additional resources:

-   [Support Options](#support-options)
-   [Resources](#resources)
-   [KendoReact Dialogs API](https://www.telerik.com/kendo-react-ui/components/dialogs/api)

## React Dialogs Library Shared Features

Among the many features which the KendoReact Dialogs deliver are:

-   **Modal**&mdash;The dialogs can be shown as modal on the page to prevent the user from interacting with other elements on the page.
-   **Resizing**&mdash;You can resize the window to change its dimensions to better view a large content.
-   **Dragging**&mdash;The window can be dragged across the page, to position it at a specific part of the page.
-   **Keyboard navigation**&mdash;The Dialogs can be controlled by the keyboard.
-   **Title and content**&mdash;You have full control over what is rendered in the dialogs title and content.
-   [**Theme support**](https://www.telerik.com/kendo-react-ui/components/styling/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-dialogs)&mdash;The KendoReact Dialogs, as well as all 120+ components in the KendoReact suite, are styled in three polished themes (Bootstrap, Material, Fluent, and Default) and can be further customized to match your specific design guidelines.

## React Dialog Component

> This is a **free React component**&mdash;no sign-up or license required.

[The KendoReact Dialog component](https://www.telerik.com/kendo-react-ui/components/dialogs/dialog/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-dialogs) is part of KendoReact and presents a modal window with content and prompts the user to take specific actions by interacting with built-in buttons for different actions. The React Dialog has the flexibility to define custom actions and buttons at the bottom of the component, referred to as the Dialog Action Buttons. By default, the KendoReact Dialog has some internal calculations for height and width, but these can easily be overridden by using the width and height bindings of the Dialog component.

How to use the Dialog component in your apps:

```tsx
import { Dialog, DialogActionsBar } from '@progress/kendo-react-dialogs';
import { Button } from '@progress/kendo-react-buttons'; // You can import any other component that allows user interaction within the DialogActionsBar. You may need to install additional dependencies, if you're not using components from the Buttons package.
...
/**
* Handle the logic for opening and closing the dialog.
* Handle the logic for the user actions within the dialog.
*/
<Dialog title={'Title'} onClose={closeDialog}>
    /**
    * Show additional dialog content, such as images and text.
    */
    <DialogActionsBar>
        /**
        * Provide user action buttons.
        */
    </DialogActionsBar>
</Dialog>
```

## React Window Component

> This is a **free React component**&mdash;no sign-up or license required.

[The KendoReact Window component](https://www.telerik.com/kendo-react-ui/components/dialogs/window/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-dialogs) displays content in a non-modal fashion and allows for the window to be moved throughout the page as well as resized based on user requirements.Each React Window has built-in action items for minimizing, maximizing and closing the window. By default, the React Window is in an uncontrolled state and can be resized or moved depending on its internal logic. For scenarios that require a controlled component, every aspect of the window can be maintained by controlling the state of the component.

How to use the Window component in your apps:

```tsx
import { Window, WindowActionsBar } from '@progress/kendo-react-dialogs';
import { Button } from '@progress/kendo-react-buttons'; // You can import any other component that allows user interaction within the WindowActionsBar. You may need to install additional dependencies, if you're not using components from the Buttons package.
...
/**
* Handle the logic for opening and closing the window.
* Handle the logic for the user actions within the window.
*/
<Window title={'Title'}>
    /**
    * Show additional window content, such as images and text.
    */
    <WindowActionsBar>
        /**
        * Provide user action buttons.
        */
    </WindowActionsBar>
</Window>
```

## Support Options

For any issues you might encounter while working with the KendoReact Dialogs, use any of the available support channels:

-   Industry-leading technical support&mdash;KendoReact paid license holders and users with an active (free) trial license can take advantage of our outstanding customer support. To submit a ticket, use [the dedicated KendoReact support system](https://www.telerik.com/account/support-center/contact-us/technical-support?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-dialogs).
-   Product forums&mdash;The [KendoReact forums](https://www.telerik.com/forums/kendo-ui-react?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-dialogs) are part of the free support you can get from the community and from the KendoReact team.
-   Feedback portal&mdash;The [KendoReact feedback portal](https://feedback.telerik.com/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-dialogs) is where you can request and vote for new features to be added.

## Resources

-   [Getting Started with KendoReact](https://www.telerik.com/kendo-react-ui/components/getting-started/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-dialogs)
-   [Get Started with KendoReact Free](https://www.telerik.com/kendo-react-ui/components/free)
-   [Getting Started with the KendoReact Dialogs](https://www.telerik.com/kendo-react-ui/components/dialogs/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-dialogs)
-   [API Reference of the KendoReact Dialogs](https://www.telerik.com/kendo-react-ui/components/dialogs/api/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-dialogs)
-   [KendoReact Roadmap](https://www.telerik.com/support/whats-new/kendo-react-ui/roadmap?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-dialogs)
-   [Blogs](https://www.telerik.com/blogs/tag/kendoreact?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-dialogs)
-   [Demos, documentation, and component reference](https://www.telerik.com/kendo-react-ui/components/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-dialogs)
-   [KendoReact pricing and licensing](https://www.telerik.com/kendo-react-ui/pricing?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-dialogs)
-   [Changelog](https://www.telerik.com/kendo-react-ui/components/changelogs/ui-for-react/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-dialogs)

High-level component overview pages:

-   [React Dialog Component](https://www.telerik.com/kendo-react-ui/dialog)
-   [React Window Component](https://www.telerik.com/kendo-react-ui/window)

_Copyright © 2025 Progress Software Corporation and/or its subsidiaries or affiliates. All Rights Reserved._

_Progress, Telerik, and certain product names used herein are trademarks or registered trademarks of Progress Software Corporation and/or one of its subsidiaries or affiliates in the U.S. and/or other countries._
